﻿
clear
do {
Write-Host "1. Creat OU"
Write-Host "2. Creat ADgroup"
Write-Host "3. Creat new ADuser"
Write-Host "4. export a ADuser list from Csv files"
Write-Host "5. ADuser"
Write-Host "6. Afslut"

$Answer = Read-Host
switch($Answer){
1{clear
try{
Write-Host "enter a name to the OU"
$OUAnswer = Read-Host
New-ADOrganizationalUnit -name $OUAnswer -Path "dc=contoso,dc=com" -ProtectedFromAccidentalDeletion $false}


catch
{
clear
write-host -foregroundcolor red "there is a mistake please try again"
}}

2{clear
Write-Host "1. Creat a new ADgroupe"
Write-Host "2. Import groupe from csv-fil"
$GroupAnswer = Read-Host

switch($GroupAnswer){
1{clear
Write-Host "enter the name to the groupe"
$GroupNameAnswer = Read-Host
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Get-ADObject -Filter {objectclass -eq 'organizationalunit'} | Sort-Object | Select-Object -ExpandProperty name
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Write-Host -ForegroundColor green "which OU the groupe will belong to?"
$GroupBelong =Read-Host
New-ADGroup -Name $GroupNameAnswer -Path "OU=$GroupBelong,DC=contoso,dc=com" -groupscope Global -ManagedBy Administrator}
2{
clear
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Get-ChildItem *.csv -recurse -path  'C:\project\csv files\'| Sort-Object | Select-Object -ExpandProperty name
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Write-Host -ForegroundColor Green "which csv file do you want to import?"
$csvAnswer = Read-Host
clear
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Get-ADObject -Filter {objectclass -eq 'organizationalunit'} | Sort-Object | Select-Object -ExpandProperty name
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Write-Host -ForegroundColor green "which OU the groupe will belong to?"
$CSVOUAnswer = Read-Host
$groups =Import-Csv "C:\project\csv files\$csvanswer"
foreach ($group in $groups){
New-ADGroup -Name $group.name -Path "OU=$CSVOUAnswer,DC=contoso,DC=COM" -Description "new groupe" -GroupCategory Security -GroupScope global -ManagedBy administrator}}}}
3{clear
Write-Host "1. creat a new user"
Write-Host "2. import from csv"
$UserAnswer = Read-Host
switch($UserAnswer){
1{
clear
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Get-ADObject -Filter {objectclass -eq 'organizationalunit'} | Sort-Object | Select-Object -ExpandProperty name
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Write-Host -ForegroundColor green "where should the groupe be located?"
$UserOUAnswer = Read-Host
clear
$brugernavn = Read-Host "what is the name of the new ADuser?"
New-ADUser -Name $brugernavn -AccountPassword (ConvertTo-SecureString -AsPlainText "Pa$$w0rd" -Force) -Path "OU=$UserOUAnswer,DC=contoso,DC=com" -ChangePasswordAtLogon $true -Enabled $true
Write-Host "the new ADuser is created with this passord : Pa$$w0rd."
$UserGroupAnswer = Read-Host "in which group this new ADuser will follow? Y/N"
switch($UserGroupAnswer){
Y{
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Get-ADGroup -SearchBase "OU=$UserOUAnswer,DC=contoso,DC=com" -filter {GroupCategory -eq "Security"} | Sort-Object | Select-Object -ExpandProperty name
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
$UserBelong = Read-Host "in which group this new ADuser will follow?" 
Add-ADGroupMember -Identity "$UserBelong" -Members "$brugernavn"}
N{
Write-Host "confirmed"}}}
2{
clear
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Get-ADObject -Filter {objectclass -eq 'organizationalunit'} | Sort-Object | Select-Object -ExpandProperty name
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Write-Host -ForegroundColor green "in which the groupe is located?"
$UserOUAnswer = Read-Host
clear
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Get-ChildItem *.csv -recurse -path  'C:\project\csv files\' | Sort-Object | Select-Object -ExpandProperty name
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Write-Host -ForegroundColor Green "which Csv file do your want to import?"
$UserCSVAnswer = Read-Host
$CSVBrugernavne = Import-Csv "C:\project\csv files\$UserCSVAnswer" -Delimiter ";"
$UserGroupAnswer = Read-Host "should the user follow a group? Y/N"
switch($UserGroupAnswer){
Y{
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Get-ADGroup -SearchBase "OU=$UserOUAnswer,DC=contoso,DC=com" -filter {GroupCategory -eq "Security"} | Sort-Object | Select-Object -ExpandProperty name
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
$UserBelong = Read-Host "which groupe the user will follow?"}
N{
Write-Host "confirmed"
break;}}
foreach($CSVBrugernavn in $CSVBrugernavne){
$Brugernavntest = "PEG_{0}" -f $CSVBrugernavn.Username
New-ADUser -Name $Brugernavntest  -AccountPassword (ConvertTo-SecureString -AsPlainText "Pa$$w0rd" -Force) -Path "OU=$UserOUAnswer,DC=contoso,DC=com" -ChangePasswordAtLogon $true -Enabled $true
Add-ADGroupMember -Identity "$UserBelong" -Members $Brugernavntest}}}}
4{
clear
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Get-ADObject -Filter {objectclass -eq 'organizationalunit'} | Sort-Object | Select-Object -ExpandProperty name
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
$UserExport = Read-Host "from which OU do you want to export?"
Get-ADUser -Filter * -SearchBase "OU=$UserExport,DC=contoso,DC=com" | Export-Csv "C:\project\csv files\\username list_$UserExport.csv"
}
5{
clear
Write-Host "1. delete a user."
Write-Host "2. delete from csv file."
Write-Host "3. change the password of the user."
$RemoveSwitch = Read-Host
switch($RemoveSwitch){ 
1{
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Get-ADUser -Filter * | Sort-Object | Select-Object -ExpandProperty name
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
$RemoveAnswer = Read-Host "which ADuser do you want to delete?"
Remove-ADUser -Identity $RemoveAnswer
}
2{
clear
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Get-ChildItem *.csv -recurse -path  'C:\project\csv files\'| Sort-Object | Select-Object -ExpandProperty name
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
$RemoveCSV = Read-Host "from which csv file do you want to delete?"
$RemoveIdentities = Import-Csv -Delimiter ";" "C:\project\csv files\$RemoveCSV"
foreach($RemoveIdentity in $RemoveIdentities){
Remove-ADUser -Identity $RemoveIdentity }
}
3{
clear
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
Get-ADUser -Filter * | Sort-Object | Select-Object -ExpandProperty name
Write-Host -ForegroundColor Red "---------------------------------------------------------------------------"
$PassUser = Read-Host "which ADuser do you want to change his name?"
$NewPassword = Read-Host "what is the new password for this ADuser?"
Set-ADAccountPassword -Identity $PassUser -Reset -NewPassword (ConvertTo-SecureString -AsPlainText $NewPassword -Force)
}}
}
}
}
while($Answer -ne 6)
 